//------------------------------------------------------
// module  : DCT.h
// auteur  : Mignotte Max
// date    : 
// version : 1.0
// langage : C++
// labo    : DIRO
// note    : 
//------------------------------------------------------
// doit etre utilis (i.e inclus) par tous les prog. ecrit en C++
// utilisant la classe DCT ou une de ses classes drive
// les fonctions correspondantes  cette classe sont defini 
// dans f_DCT.cc

#ifndef DCT_H
#define DCT_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>

#include "function.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define CARRE(X)    ((X)*(X))
#define MAXIMUM(x,y) ((x) > (y) ? (x) : (y))

//------------------------------------------------
// CLASS  DCT  -----------------------------------
//------------------------------------------------
class DCT
 { 
 //------- Data ----------
 //-----------------------
  public: 

  float**     data;
  float***    mat3d;
  float**     SquWin;

  //>Img
  int  length,width;

  //>Param
  int   size;
  int   overlap;
  float Sigma;
    
 //--------- Functions --------
 //----------------------------
  public:  
  DCT(int,int);
   ~DCT(); 

   //--------------
   //DCT Filtering 
   //--------------
   //>Hard Local Filtering 
   void FilteringDCT8x8_(float**,float);
  
   //>Threshold DCT/DST
   void HardThreshold(float,float**,int);
  
   //>Fast 8x8_DCT 
   void ddct8x8s(int,float**);

  //-------------------------------------------------
  //--- Friends Functions----------------------------
  //-------------------------------------------------
  friend float*    fmatrix_allocate_1d(int);
  friend float**   fmatrix_allocate_2d(int,int);

  friend int*    imatrix_allocate_1d(int);
  friend int**   imatrix_allocate_2d(int,int);
  friend int***  imatrix_allocate_3d(int,int,int);

  friend void free_fmatrix_1d(float*);
  friend void free_fmatrix_2d(float**);

  friend void free_imatrix_1d(int*);
  friend void free_imatrix_2d(int**);
  friend void free_imatrix_3d(int***,int);     
};
//---------------------------------------------

#endif
