//---------------------------------------------------
// module  : f_SFRBR.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "SFRBR.h"

//------------------------------------------------
// METHODES DE LA CLASSE SFRBR  -----------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe SFRBR
//----------------------------------------------------------
SFRBR::SFRBR(int** imgt,int lgth,int wdth)           
 {
  int i,j;

  //Initialisation
  length=lgth;
  width=wdth;

  if (length!=width) 
     { printf("\n Probleme Image non carree"); 
       //exit(-1); 
     }

  size_image=length;

  //Allocation memoire matrice
  mat_deg=fmatrix_allocate_2d(length,width);
  mat_img=fmatrix_allocate_2d(length,width);
  mat_rest=fmatrix_allocate_2d(length,width);
  mat_pest=fmatrix_allocate_2d(length,width);
  mat_est=fmatrix_allocate_2d(length,width);
  mat_1est=fmatrix_allocate_2d(length,width);
  mat_restbest=fmatrix_allocate_2d(length,width);

  mat_tmp0=fmatrix_allocate_2d(length,width);
  mat_tmp1=fmatrix_allocate_2d(length,width);
  mat_tmp2=fmatrix_allocate_2d(length,width);
  mat_tmp3=fmatrix_allocate_2d(length,width);
  mat_tmp4=fmatrix_allocate_2d(length,width);
  mat_tmp5=fmatrix_allocate_2d(length,width);
  mat_tmp6=fmatrix_allocate_2d(length,width);

  matcg_q=fmatrix_allocate_2d(length,width); 

  //Allocation memoire vecteur
  SumCoefsPAR=fmatrix_allocate_1d(10);
  CoefsGAUSS=fmatrix_allocate_2d(5,5);
  CoefsGAUSS2=fmatrix_allocate_1d(9);

  //Initialisation
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
     mat_img[i][j]=imgt[i][j];

  //Initialisation FLAG/Mesure
  isnr=0.0;         isnr_max=0.0;      isnr_stop=0.0;
  iter_isnr_stop=0; iter_isnr_max=0;  

  //Initialisation Coef GAUSS
  CoefsGAUSS[0][0]=1; CoefsGAUSS[0][1]=4;  CoefsGAUSS[0][2]=6;  CoefsGAUSS[0][3]=4;   CoefsGAUSS[0][4]=1;
  CoefsGAUSS[1][0]=4; CoefsGAUSS[1][1]=16; CoefsGAUSS[1][2]=24; CoefsGAUSS[1][3]=16;  CoefsGAUSS[1][4]=4;  
  CoefsGAUSS[2][0]=6; CoefsGAUSS[2][1]=24; CoefsGAUSS[2][2]=36; CoefsGAUSS[2][3]=24;  CoefsGAUSS[2][4]=6; 
  CoefsGAUSS[3][0]=4; CoefsGAUSS[3][1]=16; CoefsGAUSS[3][2]=24; CoefsGAUSS[3][3]=16;  CoefsGAUSS[3][4]=4; 
  CoefsGAUSS[4][0]=1; CoefsGAUSS[4][1]=4;  CoefsGAUSS[4][2]=6;  CoefsGAUSS[4][3]=4;   CoefsGAUSS[4][4]=1;

  //Initialisation Coef GAUSS2
  CoefsGAUSS2[0]=1;    CoefsGAUSS2[1]=4;   CoefsGAUSS2[2]=10;   CoefsGAUSS2[3]=16;
  CoefsGAUSS2[4]=19;   CoefsGAUSS2[5]=16;  CoefsGAUSS2[6]=10;   CoefsGAUSS2[7]=4;
  CoefsGAUSS2[8]=1;
 }


//----------------------------------------------------------
// Destructeur de la classe Restoration
//----------------------------------------------------------
SFRBR::~SFRBR()
{ 
  //Libere Memoire Matrice
  free_fmatrix_2d(mat_deg); 
  free_fmatrix_2d(mat_img);
  free_fmatrix_2d(mat_rest);
  free_fmatrix_2d(mat_pest);
  free_fmatrix_2d(mat_est);
  free_fmatrix_2d(mat_1est);
  free_fmatrix_2d(mat_restbest);

  free_fmatrix_2d(mat_tmp0);
  free_fmatrix_2d(mat_tmp1); 
  free_fmatrix_2d(mat_tmp2); 
  free_fmatrix_2d(mat_tmp3); 
  free_fmatrix_2d(mat_tmp4); 
  free_fmatrix_2d(mat_tmp5); 
  free_fmatrix_2d(mat_tmp6); 

  free_fmatrix_2d(matcg_q);

  //Libere Memoire Vecteur 
  free_fmatrix_1d(SumCoefsPAR);
  free_fmatrix_2d(CoefsGAUSS);
  free_fmatrix_1d(CoefsGAUSS2);
}

//-----------------//
//--CHOIX METHODE--//
//-----------------//
//----------------------------------------------------------
//  Methode d'Initialisation de restoration                     
//----------------------------------------------------------                
void SFRBR::restoration(int pf,int sz,float vrnoise)
{
 //Initialisation
 //---------------
 psf=pf;
 size=sz;
 halfsize=(int)(sz/2);
 variance_noise=vrnoise;
 
 //Information
 //-----------
 printf("\n -----");
 printf("\n  Psf     [%d]",psf);
 printf("\n  size    [%d]",size);
 printf("\n halfsize [%d]",halfsize);
 printf("\n varnoise [%.4f]",variance_noise); 
 printf("\n -----");
 printf("\n\n");

 //Degradation
 //-----------
 Degradation(mat_img,mat_deg,variance_noise);
 //if (flag_save) saveImagePgm("matdeg",mat_deg,length,width);
 //saveImagePgm("matdeg",mat_deg,length,width);

 psnr_observed=computePSNR(mat_img,mat_deg,size_image);
 printf(" >> PSNR :%.2f dB",psnr_observed);
 printf("\n >> SNR  :%.2f dB\n\n",computeSNR(mat_deg,variance_noise,size_image));


 //Methode Restoration Resultat > [mat_rest]
 //-----------------------------------------
 LandweberDCT_GGMRF();

 //Parametre Restoration-Sauvegarde
 //--------------------------------
 FillParRestoration();
 printf("\n Extension Sauvegarde:[%s]",Par_Rest);


 //Mesures [mat_rest]
 //------------------
 isnr=computeISNR(mat_img,mat_deg,mat_rest);
 if (!isnr_stop) isnr_stop=isnr;

 printf("\n");
 printf("\n Resultat Restoration");
 printf("\n --------------------");
 printf("\n ISNR_fine = [%.4f dB]",isnr);
 printf("\n ISNR_stop = [%.4f dB] (%d iters)",isnr_stop,iter_isnr_stop);
 printf("\n ISNR_maxi = [%.4f dB] (%d iters)",isnr_max,iter_isnr_max);
 printf("\n");

 //Parametre Resultat-Sauvegarde
 //-----------------------------
 FillResRestoration();
 strncat(Name_Sauve,Name_Img,3);
 strcat(Name_Sauve,"\0");
 printf("\n Extension Sauvegarde \n [%s]",Name_Sauve);
 if (flag_save) saveImagePgm(Name_Sauve,mat_rest,length,width);
}

//-----------//
//--OPTIONS--//
//-----------//
//----------------------------------------------------------
// Options                  
//----------------------------------------------------------                
void SFRBR::option(int sv,char* ch)
{
 int i,k,l;
 float sum;

 //Calcul Somme Coefs PAR
 for(i=1;i<10;i++)
    {  sum=0.0;
      for(k=-i;k<=i;k++) for(l=-i;l<=i;l++)
          sum+=1.0/(1+CARRE(k)+CARRE(l));

      SumCoefsPAR[i]=sum;  }

 //Enregistrement
 flag_save=sv;
 strcpy(Name_Img,ch);
}

//----------------------//
//--GRADIENT-LANDWEBER--//
//----------------------//
//----------------------------------------------------------
//  GradientIterLandweber
//
//  mat_est=GradientLandWeber(mat_est) 
//
//  float** matcg_q;
//
// x[k]=x[k-1]+A*(y-Ax[k])
//  
//----------------------------------------------------------     
void SFRBR::GradientIterLandweber2()
{
 float Alpha;

  //Iteration  Gradient
  //-------------------

       //h(x,y)*x[k] > mat_tmp3
       ConvolutionSquareMatrixWithPsf(mat_tmp3,mat_est,size_image);

       //g(x,y)-h(x,y)*fk(x,y) > mat_tmp4
       SubstractSquareMatrix(mat_tmp4,mat_deg,mat_tmp3,size_image);

       //h(x,y)*[g(x,y)-h(x,y)*fk(x,y)] > matcg_q
       ConvolutionSquareMatrixWithPsf(matcg_q,mat_tmp4,size_image);

       //A*q[k]
       ConvolutionSquareMatrixWithPsf(mat_tmp5,matcg_q,size_image);

       //Alpha[k] = ||q[k]||^2 / ||mat_tmp5||^2
       Alpha=DivNorm(matcg_q,mat_tmp5,size_image);
       SpeedGrad=Alpha; 
       //printf("{Speed::%.3f}",SpeedGrad); 
       
       //x[k]=x[k-1]+alpha[k].q[k]
       AddSquareMatrix(mat_est,mat_est,matcg_q,size_image,Alpha);

 //ContrainteMinMax
 ConstraintMaxMin(mat_est,size_image);
}

//------------------------//
//-----DEGRADATIONS-------//
//------------------------//
//----------------------------------------------------------
// Degradation    
//                   Utilise 
//                           mat_tmp0
//                           mat_tmp1
//----------------------------------------------------------                
void SFRBR::Degradation(float** mtin,float** mtout,float vn)
{
  int i,j,k,l,m,n;
  float sum,sumcoef,coef;
  float tmp,moy;
  float varv;

  //Presentation
  //------------
  printf("\n\n");
  printf("\n      DEGRADATION ");
  printf("\n      ----------- ");
  printf("\n");
  printf("\n [PSF=%d]",psf);

  //Init
  copy_matrix(mat_tmp1,mtin,length,width);

 
  //Convolution FLOU
  //----------------
 //--0eme PSF--
 if (psf==0) 
    for(i=0;i<length;i++) for(j=0;j<width;j++)  mtout[i][j]=mtin[i][j]; 
 
 //--1eme PSF--
 if (psf==1)
  {
    for(i=0;i<length;i++) for(j=0;j<width;j++) 
     {
      sum=0.0;
      for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
         {
           m=0;
	   if ((i+k)<0)            m=length;
           if ((i+k)>(length-1))   m=-length;

           n=0;
           if ((j+l)<0)            n=width;
           if ((j+l)>(width-1))    n=-width;

           sum+=mtin[i+k+m][j+l+n];
         }
      sum/=(CARRE(size));
      mtout[i][j]=sum;
     }
  }


 //--2eme PSF-- 
 if (psf==2)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=1.0/(1+CARRE(k)+CARRE(l));
               sumcoef+=coef;
               sum+=coef*mtin[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           mtout[i][j]=sum;
          } 
     }


 //--3eme PSF-- 
 if (psf==3)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;
                   
                sumcoef+=CoefsGAUSS[k+2][l+2];
                sum+=CoefsGAUSS[k+2][l+2]*mtin[i+k+m][j+l+n];
               }
           sum/=sumcoef;
           mtout[i][j]=sum;
        }    
    }

 //--4eme PSF-- 
  if (psf==4)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(l=-4;l<=4;l++)
            {
             n=0;
             if ((j+l)<0)            n=width;
             if ((j+l)>(width-1))    n=-width;
             sum+=CoefsGAUSS2[l+4]*mtin[i][j+l+n];
             }
           sum/=81.0;
           mtout[i][j]=sum;
        }  


      for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(k=-4;k<=4;k++)
            {
             m=0;
	     if ((i+k)<0)            m=length;
             if ((i+k)>(length-1))   m=-length;
             sum+=CoefsGAUSS2[k+4]*mtout[i+k+m][j];
               }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
         }
     for(i=0;i<length;i++) for(j=0;j<width;j++) mtout[i][j]=mat_tmp0[i][j];
    }   

  //--5eme PSF-- 
  if (psf==5)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=pow((1+((CARRE(k)+CARRE(l))/16)),-3);
               sumcoef+=coef;
               sum+=coef*mtin[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           mtout[i][j]=(int)sum;
          } 
     } 

 //Pour BSNR
 tmp=0.0;
 moy=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) moy+=mtout[i][j];
 moy/=(length*width);
 for(i=0;i<length;i++) for(j=0;j<width;j++) tmp+=CARRE(mtout[i][j]-moy);

 //Ajout BRUIT
 //-----------
 add_gaussian_noise(mtout,length,width,vn);
    
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
   { if (mtout[i][j]>255) {  mtout[i][j]=255; printf("*"); }
     if (mtout[i][j]<0)   {  mtout[i][j]=0;   printf("*"); } }

 //Verif
 varv=computeMMSE(mat_tmp1,mtout,size_image);
 printf("\n >> MMSE :%.3f",varv);

 //Pour BSNR
 tmp/=((length*width)*vn);
 bsnr_observed=10*log10(tmp);
 printf("\n >> BSNR :%.2f dB\n",bsnr_observed);
}

//------------------------//
//----MESURES ET STATS----//
//------------------------//
//----------------------------------------------------------       
// ComputeLikelihoodMMSE
//----------------------------------------------------------                
float SFRBR::ComputeLikelihoodMMSE(float** mt1,float** mt2,int sz)
{
 int i,j;
 float sum;
 float likelihoodmmse;

 //Flou
 ConvolutionSquareMatrixWithPsf(mat_tmp6,mt1,sz);

//Boucle 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=CARRE(mt2[i][j]-mat_tmp6[i][j]);

 //MMSE
 likelihoodmmse=sum;

 //retour
 return likelihoodmmse;
}

//----------------------------------------------------------
// Compute ISNR                
//----------------------------------------------------------     
float SFRBR::computeISNR(float** matimg,float** matdeg,float** matrest)
{
 int i,j;
 float num,den;
 float isnr;

 //Boucle
 num=0.0; den=0.0; 
 for(i=0;i<length;i++) for(j=0;j<width;j++) num+=CARRE(matimg[i][j]-matdeg[i][j]);
 for(i=0;i<length;i++) for(j=0;j<width;j++) den+=CARRE(matimg[i][j]-matrest[i][j]);

 //ISNR
 isnr=10*log10(num/den);

 //retour
 return isnr;
}

//----------------------------------------------------------
// MMSE               
//----------------------------------------------------------     
float SFRBR::computeMMSE(float** mat1,float** mat2,int sz)
{
 int i,j;
 float sum;
 float mmse;

 //MMSE 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=CARRE(mat2[i][j]-mat1[i][j]);

 mmse=(sum/CARRE(sz));

 //retour
 return mmse;
}

//----------------------------------------------------------
// MME               
//----------------------------------------------------------     
float SFRBR::computeMME(float** mat1,float** mat2,int sz)
{
 int i,j;
 float sum;
 float mmse;

 //MMSE 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=fabs(mat2[i][j]-mat1[i][j]);

 mmse=(sum/CARRE(sz));

 //retour
 return mmse;
}

//----------------------------------------------------------
// MME               
//----------------------------------------------------------     
float SFRBR::computeMME(float** mat,int sz)
{
 int i,j;
 float sum;
 float mmse;

 //MMSE 
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
    sum+=fabs(mat[i][j]);

 mmse=(sum/CARRE(sz));

 //retour
 return mmse;
}

//----------------------------------------------------------
// Compute PSNR                
//----------------------------------------------------------     
float SFRBR::computePSNR(float** matimg,float** matdeg,int sz)
{
 int i,j;
 float num,den;
 float psnr;

 //Boucle
 num=255.0;

 den=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) den+=CARRE(matimg[i][j]-matdeg[i][j]);
 den=sqrt(den)/sz;

 //PSNR
 psnr=20*log10(num/den);

 //retour
 return psnr;
}

//----------------------------------------------------------
// Compute SNR                
//----------------------------------------------------------     
float SFRBR::computeSNR(float** mte,float vr,int sz)
{
 int i,j;
 float vari,moyi;
 float snr;

 //Image
 vari=0.0;
 moyi=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) moyi+=mte[i][j];
 moyi/=(sz*sz);
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) vari+=CARRE(mte[i][j]-moyi);
 vari/=(sz*sz);
 printf("  (MoyImg [%.4f]   VarImg [%.4f])",moyi,vari);
 
 //SNR
 snr=10*log10(vari/vr);

 //retour
 return snr;
}


//----------------------------------------------------------       
// STAB1
//----------------------------------------------------------                
float SFRBR::computeSTAB1(float** mat,float** matp,int sz)
{
 int i,j;
 float sum;
 float den;
 float stab;

 //STAB
 sum=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) sum+=fabs(mat[i][j]-matp[i][j]);

 den=0.0;
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) den+=fabs(mat[i][j]);

 stab=(sum/den);

 //retour
 return stab;
}


//---------//
//--UTILE--//
//---------//
//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SFRBR::saveImagePgm(char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",lgth,wdth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}


//----------------------------------------------------------
// FillParRestoration     
//----------------------------------------------------------                
void SFRBR::FillParRestoration()
{
 char bufftmp[NCHAR];

 //Info
 sprintf(bufftmp,"_p%d",psf);
 strcpy(Par_Rest,bufftmp);
 
 sprintf(bufftmp,"_s%d",size);
 strcat(Par_Rest,bufftmp);

 sprintf(bufftmp,"_v%.2f",variance_noise);
 strcat(Par_Rest,bufftmp);
    
 //Copy
  strcpy(Name_Sauve,Par_Rest);
}

//----------------------------------------------------------
// FillResRestoratio 
//----------------------------------------------------------                
void SFRBR::FillResRestoration()
{
 char bufftmp[NCHAR];

 sprintf(bufftmp,"_Isnr_%.2f",isnr);
 strcpy(Par_Result,bufftmp);
 
 //Copy
 strcat(Par_Result,"-");
 strcat(Name_Sauve,Par_Result);
}

//----------------------------------------------------------
// ConvolutionSquareMatrix
//----------------------------------------------------------
void SFRBR::ConvolutionSquareMatrixWithPsf(float** matfres,float** matf,int sz)
{
 int i,j,k,l,m,n;
 float sum,sumcoef,coef;
 float nb; 

  //Convolution
  //-----------
  //--0ere PSF-- 
 if (psf==0)
    for(i=0;i<sz;i++) for(j=0;j<sz;j++) matfres[i][j]=matf[i][j];

 //--1ere PSF--  
 if (psf==1)
    {
       for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
           {
	    sum=0.0; nb=0.0;
            for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;

                sum+=matf[i+k+m][j+l+n];   
               }
             sum/=(CARRE(size));
             matfres[i][j]=sum;
          }
    }

 //--2eme PSF-- 
 if (psf==2)
    {
       for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
	      {
                m=0;
	        if ((i+k)<0)             m=length;
                if ((i+k)>(length-1))    m=-length;

                n=0;
                if ((j+l)<0)             n=width;
                if ((j+l)>(width-1))     n=-width;

                coef=1.0/(1+CARRE(k)+CARRE(l));
                sumcoef+=coef;
                sum+=coef*matf[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           matfres[i][j]=sum;
          } 
     }


 //--3eme PSF-- 
 if (psf==3)
    {
     for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
        {
         sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
               {
                m=0;
	        if ((i+k)<0)            m=length;
                if ((i+k)>(length-1))   m=-length;

                n=0;
                if ((j+l)<0)            n=width;
                if ((j+l)>(width-1))    n=-width;
              
                sumcoef+=CoefsGAUSS[k+2][l+2];
                sum+=CoefsGAUSS[k+2][l+2]*matf[i+k+m][j+l+n];
               }
           sum/=sumcoef;
           matfres[i][j]=sum;
        }    
    }
 
 //--4eme PSF-- 
  if (psf==4)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(l=-4;l<=4;l++)
            {
             n=0;
             if ((j+l)<0)            n=width;
             if ((j+l)>(width-1))    n=-width;
             sum+=CoefsGAUSS2[l+4]*matf[i][j+l+n];
             }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
        }  


      for(i=0;i<length;i++) for(j=0;j<width;j++) 
        {
         sum=0.0; 
         for(k=-4;k<=4;k++)
            {
             m=0;
	     if ((i+k)<0)            m=length;
             if ((i+k)>(length-1))   m=-length;
             sum+=CoefsGAUSS2[k+4]*mat_tmp0[i+k+m][j];
             }
           sum/=81.0;
           mat_tmp0[i][j]=sum;
         }

    for(i=0;i<length;i++) for(j=0;j<width;j++) matfres[i][j]=mat_tmp0[i][j];
    } 
  
  //--5eme PSF-- 
  if (psf==5)
    {
       for(i=0;i<length;i++) for(j=0;j<width;j++) 
          {
	   sum=0.0; sumcoef=0.0;
           for(k=-halfsize;k<=halfsize;k++) for(l=-halfsize;l<=halfsize;l++)
              {
               m=0;
	       if ((i+k)<0)            m=length;
               if ((i+k)>(length-1))   m=-length;

               n=0;
               if ((j+l)<0)            n=width;
               if ((j+l)>(width-1))    n=-width;
                    
               coef=pow((1+((CARRE(k)+CARRE(l))/16)),-3);
               sumcoef+=coef;
               sum+=coef*matf[i+k+m][j+l+n];
              }
           sum/=sumcoef;
           matfres[i][j]=(int)sum;
          } 
     } 
}

//----------------------------------------------------------
// SubstractSquareMatrix
//----------------------------------------------------------
void SFRBR::SubstractSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]-mat2[i][j]; 
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void SFRBR::AddSquareMatrix(float** matfres,float** mat1,float** mat2,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]+mat2[i][j]; 
}

//----------------------------------------------------------
// AddSquareMatrix
//----------------------------------------------------------
void SFRBR::AddSquareMatrix(float** matfres,float** mat1,float** mat2,int sz,float coef)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)  matfres[i][j]=mat1[i][j]+coef*mat2[i][j]; 
}

//----------------------------------------------------------       
// ConstraintMaxMin 
//----------------------------------------------------------                
void SFRBR::ConstraintMaxMin(float** mt,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
    {
     if (mt[i][j]>255.0)  mt[i][j]=255.0;
     if (mt[i][j]<0.0)    mt[i][j]=0.0; 
    } 
}

//----------------------------------------------------------
// DivNorm     
//----------------------------------------------------------     
float SFRBR::DivNorm(float** mat,float** matd,int sz)
{
 int i,j;
 float sum1=0.0;
 float sum2=0.0;
 float rap;

 for(i=0;i<sz;i++) for(j=0;j<sz;j++)   sum1+=CARRE(mat[i][j]);
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)   sum2+=CARRE(matd[i][j]);

 if (sum2)    rap=sum1/sum2;
 else         rap=1.0;

 return rap;
}

//----------------------------------------------------------
// GGMRFderive     
//----------------------------------------------------------     
void SFRBR::GGMRFderive(float** mat,float** matder,int sz,float lamb)
{
 int rw,cl;
 float val;
 float tmp,tmp2;
 float signe;

 //Boucle
 for(rw=0;rw<sz;rw++) for(cl=0;cl<sz;cl++) 
   {
    val=mat[rw][cl];
    tmp=0.0;

    //Cliques Horiz/Verticales
    if ((rw+1)<sz)   
       { tmp2=CLIQUE_HVER*powf(fabs(val-mat[rw+1][cl]),QPRIOR-1);
         signe=(fabs(val-mat[rw+1][cl]))/(val-mat[rw+1][cl]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }
    
    if ((rw-1)>0)        
      { tmp2=CLIQUE_HVER*powf(fabs(val-mat[rw-1][cl]),QPRIOR-1);
        signe=(fabs(val-mat[rw-1][cl]))/(val-mat[rw-1][cl]);
        if (!isnan(signe)) tmp2*=signe;
        tmp+=tmp2; }

    if ((cl+1)<sz)    
      { tmp2=CLIQUE_HVER*powf(fabs(val-mat[rw][cl+1]),QPRIOR-1);
        signe=(fabs(val-mat[rw][cl+1]))/(val-mat[rw][cl+1]);
        if (!isnan(signe)) tmp2*=signe;
        tmp+=tmp2; }

    if ((cl-1)>0)        
       { tmp2=CLIQUE_HVER*powf(fabs(val-mat[rw][cl-1]),QPRIOR-1);
         signe=(fabs(val-mat[rw][cl-1]))/(val-mat[rw][cl-1]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }

    //Cliques Diagonales
    if (((rw+1)<sz)&&((cl+1)<sz))
       { tmp2=CLIQUE_DIAG*powf(fabs(val-mat[rw+1][cl+1]),QPRIOR-1);
         signe=(fabs(val-mat[rw+1][cl+1]))/(val-mat[rw+1][cl+1]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }

    if (((rw-1)>0)&&((cl-1)>0))
       { tmp2=CLIQUE_DIAG*powf(fabs(val-mat[rw-1][cl-1]),QPRIOR-1);
         signe=(fabs(val-mat[rw-1][cl-1]))/(val-mat[rw-1][cl-1]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }

    if (((rw+1)<sz)&&((cl-1)>0))
       { tmp2=CLIQUE_DIAG*powf(fabs(val-mat[rw+1][cl-1]),QPRIOR-1);
         signe=(fabs(val-mat[rw+1][cl-1]))/(val-mat[rw+1][cl-1]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }

    if (((rw-1)>0)&&((cl+1)<sz))
       { tmp2=CLIQUE_DIAG*powf(fabs(val-mat[rw-1][cl+1]),QPRIOR-1);
         signe=(fabs(val-mat[rw-1][cl+1]))/(val-mat[rw-1][cl+1]);
         if (!isnan(signe)) tmp2*=signe;
         tmp+=tmp2; }

   //Remplissage
   tmp*=(QPRIOR)*powf(lamb,QPRIOR); 
   if (isnan(tmp)) printf("*");
   matder[rw][cl]=tmp;
   }
}

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
//------------------------//
//--METHODES RESTORATION--//
//------------------------//
//----------------------------------------------------------  
// Landweber  DCT & GGMRF   <Norm -1->
//
// <Version: Lente avec nombreux commentaires>
//
//----------------------------------------------------------     
void SFRBR::LandweberDCT_GGMRF_()
{
int k,l;
 int flag_stop;
 float map_current;
 float map_previous;
 float likelihoodmmse;
 float map_stab;
 float fon_stab;
 float DiffSquare_DCT;
 float DiffSquare_GGMRF;

 float lambda_DCT=0.0;
 float lambda_GGMRF=0.0; 

 int nb_iter=0;


 //Init matx_Est & NRJ initiale
 printf("\n        (> Init:ImgDegrad)");
 CopySquareMatrix(mat_deg,mat_1est,size_image); 
 CopySquareMatrix(mat_1est,mat_est,size_image); 

 //Init NRJ initiale
 isnr=computeISNR(mat_img,mat_deg,mat_est);
 if (isnr>isnr_max) isnr_max=isnr;
 printf(" >>>[ISNR = %.4f]\n",isnr);
 fflush(stdout);

 //Initialisation
 flag_stop=0;
 map_current=0;
 isnr=0.0; 
 isnr_max=0.0;      
 isnr_stop=0.0;
 iter_isnr_stop=0; 
 iter_isnr_max=0;

 //Initialisation objet
 dct=new DCT(length,width); 

 //Initialisation
 DiffSquare_DCT=0.0;
 DiffSquare_GGMRF=0.0;

 //Nb. Iterations 
 if (variance_noise<10)
    { lambda_DCT=1.60*sqrt(variance_noise);
      lambda_GGMRF=1.60*sqrt(variance_noise); }

 if (variance_noise>=10)
    { lambda_DCT=2.2*sqrt(variance_noise);
      lambda_GGMRF=2.2*sqrt(variance_noise); }

 nb_iter=MAX(400,(int)(1500/variance_noise));
 

 //Presentation
 printf("\n     --------------------------------"); 
 printf("\n       LandWeber DCT & GGMRF         ");
 printf("\n     --------------------------------");
 printf("\n        (> PSF: [%d]  SizePsf: [[Half*2]+1] %d = %d [Size])",psf,(halfsize*2)+1,size); 
 printf("\n        (> VarianceNoise: [%.2f])",variance_noise);
 printf("\n        (> SizeImage: [%d])",size_image);
 printf("\n        -----------------");
 printf("\n        (> Gamma 1.6 sigma  : [%.4f])",lambda_DCT);
 printf("\n        (> NbIter  : Automatic> [%d])",nb_iter);  
 printf("\n        -----------------");
 printf("\n"); 

 
 //Info
 printf("\n        INFO MATRIX >>"); 
 InfoMatrix(mat_est,size_image);
 //saveImagePgm("ImgDegrad",mat_est,length,width);
 //printf("\n\n"); 

 //Initialisation
 isnr_max=0;
 iter_isnr_max=0;
  
 //-----------------------------------------------------
 //Estimation Parametre GGMRF
 //-----------------------------------------------------
 float lambda_GGMRF_min=0.0;
 float lambda_GGMRF_max=lambda_GGMRF;

  printf("\n         >>> ESTIMATION >GGMRF"); 
  for(k=1;k<2;k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_tmp2,size_image); 
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
     GradientIterLandweber2();

     //DiffSquare_DCT
     CopySquareMatrix(mat_est,mat_tmp1,size_image);
     (*dct).FilteringDCT8x8_(mat_est,lambda_DCT);   
     DiffSquare_DCT=computeMME(mat_est,mat_tmp1,size_image);                                       
       
     //DiffSquare_GGMRF
     lambda_GGMRF=lambda_GGMRF_max/2.0;
     for(l=1;l<40;l++)                           
        { 
         GGMRFderive(mat_pest,mat_tmp1,size_image,lambda_GGMRF);
         DiffSquare_GGMRF=computeMME(mat_tmp1,size_image);                                        

         if (fabs(DiffSquare_GGMRF-DiffSquare_DCT)<0.00001)   
            break;
         
         if (DiffSquare_GGMRF>DiffSquare_DCT) 
	    { lambda_GGMRF_max=lambda_GGMRF;
              lambda_GGMRF/=2.0; }

         if (DiffSquare_GGMRF<DiffSquare_DCT) 
	    { lambda_GGMRF_min=lambda_GGMRF;
              lambda_GGMRF=lambda_GGMRF+(lambda_GGMRF_max-lambda_GGMRF)/2.0; }

         printf("\n    [DCT:%.3f> Nrj=%.3f]",lambda_DCT,DiffSquare_DCT*1000);
         printf("[GGMRF:%.3f> nrj=%.3f]",SpeedGrad*lambda_GGMRF,DiffSquare_GGMRF*1000);     
        }   

     CopySquareMatrix(mat_tmp2,mat_est,size_image); 
    }
  printf("\n");
 

 //-----------------------------------------------------------
 // Boucle LandWeber + Contrainte DCT & GGMRF <UNSUPERVISED>
 //-----------------------------------------------------------                                 
 for(k=1;(k<nb_iter);k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
      GradientIterLandweber2();    

     //ContraintesDCT[mat_est]<[mat_pest] 
     if (k%2)    
        { CopySquareMatrix(mat_est,mat_tmp1,size_image);
          (*dct).FilteringDCT8x8_(mat_est,lambda_DCT);   
          DiffSquare_DCT=computeMME(mat_est,mat_tmp1,size_image);                                       
          if (k>3) printf(" [DCT:%.3f]",lambda_DCT); }
       
     //ContraintesGGMRF[mat_est]<[mat_pest]
     if (!(k%2)) 
       { 
         GGMRFderive(mat_pest,mat_tmp1,size_image,lambda_GGMRF); 
         AddSquareMatrix(mat_est,mat_est,mat_tmp1,size_image,-1.00); 
         DiffSquare_GGMRF=computeMME(mat_est,mat_pest,size_image);                                           
         printf(" [GGMRF:%.3f]",SpeedGrad*lambda_GGMRF);
         if (k>2) 
	   { if (DiffSquare_GGMRF>DiffSquare_DCT) { lambda_GGMRF-=0.05*lambda_GGMRF; printf("-"); }        
             if (DiffSquare_GGMRF<DiffSquare_DCT) { lambda_GGMRF+=0.05*lambda_GGMRF; printf("+"); } } }    
   
     //Mesures[mat_est]
     map_previous=map_current; 
     isnr=computeISNR(mat_img,mat_deg,mat_est);
     likelihoodmmse=ComputeLikelihoodMMSE(mat_est,mat_deg,size_image);
     map_current=likelihoodmmse;   
              
     map_stab=fabs((map_current-map_previous)/(map_current));
     fon_stab=computeSTAB1(mat_est,mat_pest,size_image);

     printf("\n [%d>ISNR = %.4f]",k,isnr);
     printf(" [NrjML = %.1f]",map_current/(size_image*size_image));
     printf(" [[NrjML/sigma^2 = %.4f]]",map_current/(size_image*size_image*variance_noise));
     fflush(stdout); 

     if (isnr>isnr_max) { isnr_max=isnr; iter_isnr_max=k; }   
    }
 //--------------------------------------------------------

  //Record
  isnr_stop=isnr;  
  iter_isnr_stop=k-1; 
  CopySquareMatrix(mat_est,mat_restbest,size_image);

  //Copiage Resultat Final
  CopySquareMatrix(mat_est,mat_rest,size_image);  

  //NRJ-ML
  printf("\n\n Energie ML : %.4f\n",ComputeLikelihoodMMSE(mat_est,mat_deg,size_image));  
}

//----------------------------------------------------------  
// Landweber  DCT & GGMRF   <Norm -1->
//
// <Version: sans nombreux commentaires>
//
//----------------------------------------------------------     
void SFRBR::LandweberDCT_GGMRF()
{
int k,l;
 int flag_stop;
 float map_current;
 float DiffSquare_DCT;
 float DiffSquare_GGMRF;

 float lambda_DCT=0.0;
 float lambda_GGMRF=0.0; 

 int nb_iter=0;

 //Verif
 //for(k=0;k<size_image;k++) for(l=0;l<size_image;l++)
 //mat_img[k][l]=0.0;

 //Init matx_Est & NRJ initiale
 printf("\n        (> Init:ImgDegrad)");
 CopySquareMatrix(mat_deg,mat_1est,size_image); 
 CopySquareMatrix(mat_1est,mat_est,size_image); 

 //Init NRJ initiale
 isnr=computeISNR(mat_img,mat_deg,mat_est);
 if (isnr>isnr_max) isnr_max=isnr;
 printf(" >>>[ISNR = %.4f]\n",isnr);
 fflush(stdout);

 //Initialisation
 flag_stop=0;
 map_current=0;
 isnr=0.0; 
 isnr_max=0.0;      
 isnr_stop=0.0;
 iter_isnr_stop=0; 
 iter_isnr_max=0;

 //Initialisation objet
 dct=new DCT(length,width); 

 //Initialisation
 DiffSquare_DCT=0.0;
 DiffSquare_GGMRF=0.0;

 //Nb. Iterations 
 if (variance_noise<10)
    { lambda_DCT=1.60*sqrt(variance_noise);
      lambda_GGMRF=1.60*sqrt(variance_noise); }

 if (variance_noise>=10)
    { lambda_DCT=2.2*sqrt(variance_noise);
      lambda_GGMRF=2.2*sqrt(variance_noise); }

 nb_iter=MAX(400,(int)(1500/variance_noise));
 

 //Presentation
 printf("\n     ----------------------------------"); 
 printf("\n       SFRBR [LandWeber DCT & GGMRF]   ");
 printf("\n     ----------------------------------");
 printf("\n        (> PSF: [%d]  SizePsf: [[Half*2]+1] %d = %d [Size])",psf,(halfsize*2)+1,size); 
 printf("\n        (> VarianceNoise: [%.2f])",variance_noise);
 printf("\n        (> SizeImage: [%d])",size_image);
 printf("\n        -----------------");
 printf("\n        (> Gamma 1.6 sigma  : [%.4f])",lambda_DCT);
 printf("\n        (> NbIter  : Automatic> [%d])",nb_iter);  
 printf("\n        -----------------");
 printf("\n"); 
 
 //Info
 printf("\n        INFO MATRIX >>"); 
 InfoMatrix(mat_est,size_image);
 //saveImagePgm("ImgDegrad",mat_est,length,width);
 //printf("\n\n"); 

 //Initialisation
 isnr_max=0;
 iter_isnr_max=0;
  
 //-----------------------------------------------------
 //Estimation Parametre GGMRF
 //-----------------------------------------------------
 float lambda_GGMRF_min=0.0;
 float lambda_GGMRF_max=lambda_GGMRF;

  printf("\n         >>> ESTIMATION >GGMRF"); 
  for(k=1;k<2;k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_tmp2,size_image); 
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
     GradientIterLandweber2();

     //DiffSquare_DCT
     CopySquareMatrix(mat_est,mat_tmp1,size_image);
     (*dct).FilteringDCT8x8_(mat_est,lambda_DCT);   
     DiffSquare_DCT=computeMME(mat_est,mat_tmp1,size_image);                                       
       
     //DiffSquare_GGMRF
     lambda_GGMRF=lambda_GGMRF_max/2.0;
     for(l=1;l<40;l++)                           
        { 
         GGMRFderive(mat_pest,mat_tmp1,size_image,lambda_GGMRF);
         DiffSquare_GGMRF=computeMME(mat_tmp1,size_image);                                        

         if (fabs(DiffSquare_GGMRF-DiffSquare_DCT)<0.00001)   
            break;
         
         if (DiffSquare_GGMRF>DiffSquare_DCT) 
	    { lambda_GGMRF_max=lambda_GGMRF;
              lambda_GGMRF/=2.0; }

         if (DiffSquare_GGMRF<DiffSquare_DCT) 
	    { lambda_GGMRF_min=lambda_GGMRF;
              lambda_GGMRF=lambda_GGMRF+(lambda_GGMRF_max-lambda_GGMRF)/2.0; }

         if (!(l%10))
	   { printf("\n    [DCT:%.3f> Nrj=%.3f]",lambda_DCT,DiffSquare_DCT*1000);
             printf("[GGMRF:%.3f> nrj=%.3f]",SpeedGrad*lambda_GGMRF,DiffSquare_GGMRF*1000); }
        }   

     CopySquareMatrix(mat_tmp2,mat_est,size_image); 
    }
  printf("\n");


 //-----------------------------------------------------------
 // Boucle LandWeber + Contrainte DCT & GGMRF <UNSUPERVISED>
 //-----------------------------------------------------------                                 
 for(k=1;(k<nb_iter);k++)
    {
     //Gestion
     CopySquareMatrix(mat_est,mat_pest,size_image); 

     //IterationLandWeber[mat_est]
      GradientIterLandweber2();    

     //ContraintesDCT[mat_est]<[mat_pest] 
     if (k%2)    
        { CopySquareMatrix(mat_est,mat_tmp1,size_image);
          (*dct).FilteringDCT8x8_(mat_est,lambda_DCT);   
          DiffSquare_DCT=computeMME(mat_est,mat_tmp1,size_image); }
       
     //ContraintesGGMRF[mat_est]<[mat_pest]
     if (!(k%2)) 
       { 
         GGMRFderive(mat_pest,mat_tmp1,size_image,lambda_GGMRF); 
         AddSquareMatrix(mat_est,mat_est,mat_tmp1,size_image,-1.00); 
         DiffSquare_GGMRF=computeMME(mat_est,mat_pest,size_image);                                           
         if (k>2) 
	   { if (DiffSquare_GGMRF>DiffSquare_DCT) { lambda_GGMRF-=0.05*lambda_GGMRF; }        
             if (DiffSquare_GGMRF<DiffSquare_DCT) { lambda_GGMRF+=0.05*lambda_GGMRF; } } }    
   
     //Mesures[mat_est]
     if ((!(k%10))||(k==(nb_iter-1)))
        {  isnr=computeISNR(mat_img,mat_deg,mat_est);   
           printf("\n [%d>ISNR = %.4f]",k,isnr);
           fflush(stdout); }

     if (isnr>isnr_max) { isnr_max=isnr; iter_isnr_max=k; }   
    }
 //--------------------------------------------------------

  //Record
  isnr_stop=isnr;  
  iter_isnr_stop=k-1; 
  CopySquareMatrix(mat_est,mat_restbest,size_image);

  //Copiage Resultat Final
  CopySquareMatrix(mat_est,mat_rest,size_image);  

  //NRJ-ML
  printf("\n\n Energie ML : %.4f\n",ComputeLikelihoodMMSE(mat_est,mat_deg,size_image));  
}

//----------------------------------------------------------
//----------------------------------------------------------  
